#include <RefSys.H>


const bool debugRefSys = false ;

RefSys::RefSys
()
{
   origen = Vector3d(0.0,0.0,0.0) ;

   eje[X] = Vector3d(1.0,0.0,0.0) ;
   eje[Y] = Vector3d(0.0,1.0,0.0) ;
   eje[Z] = Vector3d(0.0,0.0,1.0) ;
}

RefSys::RefSys
(
   const Vector3d & _origen ,
   const Vector3d & _ejex ,
   const Vector3d & _ejey ,
   const Vector3d & _ejez
)
{
   origen = _origen ;

   eje[X] = _ejex ;
   eje[Y] = _ejey ;
   eje[Z] = _ejez ;
}

Vector3d RefSys::VectorLocalAGlobal
(
   const Vector3d & v
)
   const
{
   Vector3d res = Vector3d(0,0,0) ;

   for( int i=0 ; i < 3 ; i++ )
      res += ( v(i)*eje[i] ) ;

   return res ;
}

Vector3d RefSys::PuntoLocalAGlobal
(
   const Vector3d & v
)
   const
{
   return origen + VectorLocalAGlobal( v )  ;
}

RefSys RefSys::Escalar
(
   double ex,
   double ey,
   double ez

)
   const
{

   return RefSys( origen, eje[X]*ex, eje[Y]*ey, eje[Z]*ez ) ;
}


RefSys RefSys::DesplRotarY
(
   double desplY ,
   double angRotaX ,
   double angRotaY
)
   const
{

   if ( debugRefSys )
   {
      std::cout << std::endl << "*** entra DesplRotarY"
           << std::endl << " desplY = " << desplY
           << std::endl << " angRotaX = " << angRotaX
           << std::endl << " angRotaY = " << angRotaY
           << std::endl << " origen   = " << origen
           << std::endl << " eje[Y]   = " << eje[Y]
           << std::flush ;
   }


   Vector3d origenNuevo = origen + (desplY * eje[Y]) ,
            versorLocal[3],
            ejeNuevo[3],
            versorGlobalNorm[3] ;


   versorLocal[0] = Vector3d(1,0,0) ;
   versorLocal[1] = Vector3d(0,1,0) ;
   versorLocal[2] = Vector3d(0,0,1) ;

   double longitud[3] ;

   // este algoritmo es complicado, pero permite sistemas de
   // referencias ortogonales de vectores con longitudes no
   // necesariamente unidad (es lo que queremos).

   for( unsigned i=0 ; i < 3 ; i ++ )
   {
       Vector3d   v = eje[i] ;

       longitud[i]     = v.Module() ;
       versorGlobalNorm[i] = v.Normalized() ;
   }

   Transformd rotacion = TRotation(X,angRotaX) * TRotation(Y,angRotaY) ;

   for( unsigned i = 0 ; i < 3 ; i ++ )
   {
      Vector3d
          versorLocalRotado_i   = versorLocal[i] * rotacion ,
          versorGlobalRotado_i  = Vector3d(0,0,0) ;

      for( unsigned j =0 ; j < 3 ; j ++ )
      {
             versorGlobalRotado_i += versorLocalRotado_i[j] * versorGlobalNorm[j] ;
      }

      ejeNuevo[i] = longitud[i] * versorGlobalRotado_i ;
   }

   return RefSys( origenNuevo, ejeNuevo[X], ejeNuevo[Y], ejeNuevo[Z] ) ;
}


